# coding: utf-8

"""
Slices Experiment Authority

The Slices Experiment Authority API

The version of the OpenAPI document: 0.1.0
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""  # noqa: E501

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from slices_expauth_client.models.experiment_resource import ExperimentResource
from slices_expauth_client.models.page_link import PageLink
from typing import Optional, Set
from typing_extensions import Self


class ExperimentResourcePage(BaseModel):
    """
    ExperimentResourcePage
    """  # noqa: E501

    experiment_resource_links: List[PageLink]
    experiment_resources: List[ExperimentResource]
    total: Optional[StrictInt] = None
    __properties: ClassVar[List[str]] = ["experiment_resource_links", "experiment_resources", "total"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExperimentResourcePage from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in experiment_resource_links (list)
        _items = []
        if self.experiment_resource_links:
            for _item in self.experiment_resource_links:
                if _item:
                    _items.append(_item.to_dict())
            _dict["experiment_resource_links"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in experiment_resources (list)
        _items = []
        if self.experiment_resources:
            for _item in self.experiment_resources:
                if _item:
                    _items.append(_item.to_dict())
            _dict["experiment_resources"] = _items
        # set to None if total (nullable) is None
        # and model_fields_set contains the field
        if self.total is None and "total" in self.model_fields_set:
            _dict["total"] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExperimentResourcePage from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "experiment_resource_links": [PageLink.from_dict(_item) for _item in obj["experiment_resource_links"]]
                if obj.get("experiment_resource_links") is not None
                else None,
                "experiment_resources": [ExperimentResource.from_dict(_item) for _item in obj["experiment_resources"]]
                if obj.get("experiment_resources") is not None
                else None,
                "total": obj.get("total"),
            }
        )
        return _obj
